import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/web.dom.iterable";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import classnames from 'classnames';
import PropTypes from 'prop-types';
import withStyles from '@material-ui/core/styles/withStyles'; // https://developers.google.com/web/fundamentals/performance/lazy-loading-guidance/images-and-video/

function lazyLoadImages(element) {
  if (!element) return;

  var lazyImages = _toConsumableArray(element.querySelectorAll('[data-rsf-lazy]'));

  if (!lazyImages.length) return;
  var lazyImageObserver;

  var observerHandler = function observerHandler(entries) {
    entries.forEach(function (entry) {
      if (entry.isIntersecting) {
        var lazyImage = entry.target;
        lazyImage.src = lazyImage.dataset.src;
        lazyImageObserver.unobserve(lazyImage);
      }
    });
  };

  try {
    lazyImageObserver = new window.IntersectionObserver(observerHandler);
    lazyImages.forEach(function (lazyImage) {
      lazyImageObserver.observe(lazyImage);
    });
  } catch (e) {
    // eagerly load images when we don't have the observer
    lazyImages.forEach(function (lazyImage) {
      lazyImage.src = lazyImage.dataset.src;
    });
  }
}

export var styles = function styles(theme) {
  return {
    inline: {
      display: 'inline'
    },
    block: {
      display: 'block'
    }
  };
};
/**
 * A container for HTML blob content from a CMS.  Content is dangerously inserted into the DOM.
 * Pass the html as a string as the child of this component. Additional props are spread to the
 * rendered span element.
 */

var CmsSlot = (_dec = withStyles(styles, {
  name: 'RSFCmsSlot'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(CmsSlot, _Component);

  function CmsSlot() {
    _classCallCheck(this, CmsSlot);

    return _possibleConstructorReturn(this, _getPrototypeOf(CmsSlot).apply(this, arguments));
  }

  _createClass(CmsSlot, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      lazyLoadImages(this.el);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this,
          _classnames;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          classes = _this$props.classes,
          inline = _this$props.inline,
          others = _objectWithoutProperties(_this$props, ["children", "className", "classes", "inline"]);

      return children ? React.createElement("span", _extends({
        ref: function ref(el) {
          return _this.el = el;
        }
      }, others, {
        className: classnames(className, (_classnames = {}, _defineProperty(_classnames, classes.inline, inline), _defineProperty(_classnames, classes.block, !inline), _classnames)),
        dangerouslySetInnerHTML: {
          __html: children
        }
      })) : null;
    }
  }]);

  return CmsSlot;
}(Component), _defineProperty(_class2, "proptypes", {
  /**
   * Use inline prop to use display:inline style
   */
  inline: PropTypes.boolean
}), _temp)) || _class);
export { CmsSlot as default };
//# sourceMappingURL=CmsSlot.js.map